#include "ShaderConstants.fxh"

struct PS_Input
{
    float4 position : SV_Position;
	
	float3 cloud : CLOUD;
	
    float4 color : COLOR;

};

struct PS_Output
{
    float4 color : SV_Target;
};

float hash(float2 p)
{

    p = frac(p * 0.1031);
    p += dot(p, p.xy + 19.19);
	
    return frac((p.x + p.y) * p.y);
}

float4 noise( float2 p )
{
    float2 i = floor( p );
    float2 f = frac( p );
	float2 u = f*f*(3.0-2.0*f);

    return lerp( lerp( hash( i + float2(0.0,0.0) ), hash( i + float2(1.0,0.0) ), u.x),lerp( hash( i + float2(0.0,1.0) ), hash( i + float2(1.0,1.0) ), u.x), u.y);
}
float4 cloudH( float2 x) {

	float2 xy = x;
	float h = 0.0;
	float f = 0.0;
    for (float i=1.0;i<10.0;i++) {
        h +=noise(xy*pow(2.6, i))*0.9*pow(0.425, i);
    }
    	f = 0.5000*noise( xy ); 
		xy = xy*pow(0.1, i);
        f += 0.2500*noise( xy ); 
		xy = xy*pow(0.31, i);
        f += 0.1250*noise( xy ); 
		xy = xy*pow(0.32, i);
        f += 0.0625*noise( xy );
	float n = f+h;
	
	return saturate(smoothstep(0.0, 1.0, pow(max(n - 0.5, 0.0) * (1.0 / (1.0 - 0.5)), 0.5)));
}
void main( in PS_Input PSInput, out PS_Output PSOutput )
{	
	float4 f = FOG_COLOR;

	float4 cloudc = float4(1.0,1.0,1.0,10.0);

	float2 xz = float2(PSInput.cloud.x,PSInput.cloud.z)/7.0;
	
	xz *= cloudc.a*10.0;

	xz.x += TIME*0.0075;

	float2 c1 = cloudH( float2(xz.x + TIME * 0.0075,xz.y));

    float2 c2 = cloudH( float2(xz.x + TIME * 0.009,xz.y));
	
	float2 c3 = cloudH( float2(xz.x * 2.5 + TIME * 0.11,xz.y * 2.5));

	cloudc.a = (lerp( c3 , c2 , c1 ) * c1 * 2.0);
	
	cloudc = float4( f.rgb , cloudc.a );

	PSInput.color.rgb = lerp( PSInput.color.rgb , cloudc.rgb , cloudc.a );
 
	PSOutput.color = PSInput.color;
}