#include "ShaderConstants.fxh"

struct VS_Input
{
    float3 position : POSITION;
    float4 color : COLOR;
#ifdef INSTANCEDSTEREO
	uint instanceID : SV_InstanceID;
#endif
};


struct PS_Input
{
    float4 position : SV_Position;
	float3 cloud : CLOUD;
	float4 color : COLOR;
#ifdef INSTANCEDSTEREO
	uint instanceID : SV_InstanceID;
#endif
};
void main( in VS_Input VSInput, out PS_Input PSInput )
{
#ifdef INSTANCEDSTEREO
	int i = VSInput.instanceID;
	PSInput.position = mul( WORLDVIEWPROJ_STEREO[i], float4( VSInput.position, 1 ) );
	PSInput.instanceID = i;
#else
	PSInput.position = mul(WORLDVIEWPROJ, float4(VSInput.position, 1));
#endif

	PSInput.cloud = VSInput.position;
	
	float4 Fog =FOG_COLOR;
	
    float4 c =CURRENT_COLOR;
	
    float4 far_fog =Fog;
	
    float dark_rain = max(c.b*1.5,0.1);

    float4 sky_color = lerp(float4(lerp( float3(0.25, 0.43, 0.7),float3(0.34, 0.56, 0.8),Fog.a),1.3)*dark_rain,float4(c.r*0.5,c.g*0.75,min(Fog.b,c.b),c.a),pow(FOG_CONTROL.y,5.0));
    
	sky_color.rgb = max(sky_color.rgb,float3(0.0,0.1,0.2));

    float mid = VSInput.color.r;
	
    PSInput.color = sky_color*(1.0-mid)+far_fog*(mid);//Creeper
}